//	Usart.c							   2006.03.02

/////////////////////////////////////////////////////////////////////////////

void	Init_Usart(void)
{
SPBRG = 0x07;	//	baud rate = 115200 @ 14.7456MHz (see table)
BRGH = 1;	//	High speed
SYNC = 0;	//	asynchronous mode               
SPEN = 1;	//	serial port enable             
TX9 = 1;	//	9 bits                           
RX9 = 1;	//	9 bits                          
TXEN = 1;	//	Tx enable                      
CREN = 1;	//	Continuous receive enable

PEIE = 1;	//	Enable Periferal
RCIE = 1;	//	Enable Reciver Irq
TXIE = 0;	//	Disable Transmitter Irq

Usart_Error_Cnt = 0;
Usart_Ptr_First = 0;
Usart_Ptr_Last = 0;
}

/////////////////////////////////////////////////////////////////////////////

void	Usart_Rc_Irq(void)					 // Interrupt
{
				    //    64   91

if (RCIF == 0)		return;			//   

Rc_Status = RCSTA;
Received = RCREG;

if (Rc_Status & 2)				// Overrun Error
   {
   err |= '2';
   Usart_Error_Cnt++;
   CREN = 0;
   CREN = 1;
   }

if (Rc_Status & 4)				// Frame Error
   {
   err |= '4';
   Usart_Error_Cnt++;
   }

Rc_Status &= 1;

Usart_Rc_Parity  = Received;
if (Received & 0x02)	Usart_Rc_Parity++;
if (Received & 0x04)	Usart_Rc_Parity++;
if (Received & 0x08)	Usart_Rc_Parity++;
if (Received & 0x10)	Usart_Rc_Parity++;
if (Received & 0x20)	Usart_Rc_Parity++;
if (Received & 0x40)	Usart_Rc_Parity++;
if (Received & 0x80)	Usart_Rc_Parity++;
Usart_Rc_Parity &= 1;

if (Usart_Rc_Parity == Rc_Status)		// Parity Error
   {
   err |= '1';
   Usart_Error_Cnt++;
   }

Rc_Irq_tmp = Usart_Ptr_Last - Usart_Ptr_First;
Rc_Irq_tmp &= BUFF_SIZE;
if (Rc_Irq_tmp == BUFF_SIZE)			// Soft overrun error
   {
   Usart_Error_Cnt++;
   err |= '8';
   return;
   }

Usart_Buffer[Usart_Ptr_Last] = Received;
Usart_Ptr_Last++;
Usart_Ptr_Last &= BUFF_SIZE;

}

/////////////////////////////////////////////////////////////////////////////

char	Test_Buffer(void)		// ,    
{
Test_Buffer_tmp = Usart_Ptr_Last - Usart_Ptr_First;
Test_Buffer_tmp &= BUFF_SIZE;
return Test_Buffer_tmp;
}

/////////////////////////////////////////////////////////////////////////////

char	Get_Byte(void)			//      
{
Get_Byte_tmp = Usart_Ptr_Last - Usart_Ptr_First;
Get_Byte_tmp &= BUFF_SIZE;
if (Get_Byte_tmp == 0)			return 0xFF;	//  

Get_Byte_byte = Usart_Buffer[Usart_Ptr_First];
if (Usart_Ptr_First == BUFF_SIZE)	Usart_Ptr_First = 0;
  else					Usart_Ptr_First++;
return Get_Byte_byte;
}

/////////////////////////////////////////////////////////////////////////////

void	Send_Byte(char byte)		//     
{
while (!TXIF);				//   

Usart_Tx_Parity = byte;
if ((byte & 0x02))	Usart_Tx_Parity++;
if ((byte & 0x04))	Usart_Tx_Parity++;
if ((byte & 0x08))	Usart_Tx_Parity++;
if ((byte & 0x10))	Usart_Tx_Parity++;
if ((byte & 0x20))	Usart_Tx_Parity++;
if ((byte & 0x40))	Usart_Tx_Parity++;
if ((byte & 0x80))	Usart_Tx_Parity++;

if ((Usart_Tx_Parity & 1))	TX9D = 0;
  else				TX9D = 1;
TXREG = byte;
}

/////////////////////////////////////////////////////////////////////////////
