#include <htc.h>        /* HiTech General Include File */

#include <stdint.h>        /* For uint8_t definition */
#include <stdbool.h>       /* For true/false definition */

#include "system.h"        /* System funct/params, like osc/peripheral config */
#include "user.h"          /* User funct/params, such as InitApp */

/******************************************************************************/
/* User Global Variable Declaration                                           */
/******************************************************************************/

/* i.e. uint8_t <variable_name>; */

/******************************************************************************/
/* Main Program                                                               */
/******************************************************************************/

//			Test

#define		VERSION		D926
//				YMDD

/////////////////////////////////////////////////////////////////////////////

#include	<pic.h>
#include	"test.h"
#include	"ram.h"
#include	"ports.h"
#include	"usart.h"

/////////////////////////////////////////////////////////////////////////////

__IDLOC(VERSION);

__CONFIG(0x3F36);	// 11.1111.0011.0110  code protect off = Pic16f877A

/////////////////////////////////////////////////////////////////////////////

#include	"timer0.c"	// Ok
#include	"usart.c"	//
#include	"lib.c" 	//
#include	"pwm.c" 	//

#include	"ports.c"	// Ok
#include	"mainloop.c"	//

/////////////////////////////////////////////////////////////////////////////

void	main(void)
{
INTCON = 0;
Init_Ports();
Init_Usart();
Init_Timer0();

   LEDY = 1;

WAKE = 1;

GIE = 1;

Send_Byte('-');
Send_Byte('-');
Send_Byte('-');
Send_Byte('-');
Send_Byte('-');
Send_Byte(' ');
Send_Byte(' ');
Send_Hex2(0xVERSION);
Send_Byte(' ');
Send_Byte(' ');
Send_Byte('-');
Send_Byte('-');
Send_Byte('-');
Send_Byte('-');
Send_Byte('-');
Send_Byte(0x0D);
Send_Byte(0x0D);

Send_Byte('+');
Send_Byte(' ');
Send_Byte('i');
Send_Byte('n');
Send_Byte('c');
Send_Byte(' ');
Send_Byte('P');
Send_Byte('W');
Send_Byte('M');
Send_Byte(',');
Send_Byte(' ');
Send_Byte('-');
Send_Byte(' ');
Send_Byte('d');
Send_Byte('e');
Send_Byte('c');
Send_Byte('.');
Send_Byte(0x0D);

   LEDY = 0;

MainLoop();
}

/////////////////////////////////////////////////////////////////////////////
